/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021-03-29
 **/
!(function () {

    //编辑配置
    var createEditLine = function(label,value,ref,action){
        return {
            type: 'bi.left',
            items: [
                {
                    type: 'bi.label',
                    cls: 'bi-font-bold',
                    width: 100,
                    textAlign: 'left',
                    text: label
                },
                {
                    type: 'bi.text_editor',
                    width: 300,
                    allowBlank: true,
                    ref: ref,
                    value:value,
                    listeners: [{
                        eventName: BI.FormulaEditor.EVENT_CHANGE,
                        action: action
                    }]
                }
            ]
        };
    }
    var DemoEditName = 'dec.dcm.connection.plugin.demo.edit';
    var DemoEdit = BI.inherit(BI.Widget, {
        props: {
            value:{
                key: ''
            },
            connectionName:''
        },
        render() {
            var self = this;
            var o = this.options;
            return {
                type: 'bi.vertical',
                hgap: 15,
                vgap: 10,
                items: [
                    createEditLine(
                        '数据源名称',
                        o.connectionName,//self._parent.options.formData.connectionName,
                        function(_ref) {
                            self.name = _ref;
                        },
                        //hugh:2021-04-02，截止目前的所有发布版本均不支持getName方法修改数据源连接名称，需要使用下面这种非常不友好的方式修改
                        function () {
                            self._parent.options.formData.connectionName = this.getValue();
                        }
                    ),
                    createEditLine(
                        'key值',
                        o.value.key,
                        function(_ref) {
                            self.key = _ref;
                        },
                        function () {}
                    )
                ]
            };
        },
        getValue() {
            return {
                key: this.key.getValue()
            };
        },
        //hugh:2021-04-02下个小版本应该就支持直接使用getName来返回要修改的数据源链接名称了
        getName(){
            return this.name.getValue();
        }
    });
    BI.shortcut(DemoEditName, DemoEdit);

    //显示配置
    var DemoShowName = 'dec.dcm.connection.plugin.demo.show';
    var DemoShow = BI.inherit(BI.Widget, {
        props: {
            value: {
                key: ''
            }
        },
        render() {
            var o = this.options;
            return {
                type: 'bi.vertical',
                hgap: 15,
                vgap: 10,
                items: [
                    {
                        type: 'bi.left',
                        items: [
                            {
                                type: 'bi.label',
                                cls: 'bi-font-bold',
                                width: 100,
                                textAlign: 'left',
                                text: 'Key值'
                            },
                            {
                                type: 'bi.label',
                                text: o.value.key
                            }
                        ]
                    }
                ]
            };
        }
    });

    BI.shortcut(DemoShowName, DemoShow);
    //注册
    BI.config('dec.connection.provider.datebase', function(provider){
        provider.registerDatabaseType({
            text: 'Demo Conn',
            databaseType: 'demo_con',
            iconUrl: 'com/tptj/demo/hg/connection/images/demo.jpg',
            edit: DemoEditName,
            show: DemoShowName,
        });
    });
})();